#include <iostream>
#include <algorithm>
using namespace std;

const int maxn = 401;
int n, k, p;
int a[maxn];
int lleft[maxn], rright[maxn];

pair<int, int> ordered[maxn];

int main() {
    cin >> n >> k >> p;
    for (int i = 0; i < n; i++) a[i] = i+1;
    int cc = 0;
    do {
        for (int i = 0; i < n-1; i++) rright[i] = i+1;
        for (int i = 1; i < n; i++) lleft[i] = i-1;
        rright[n-1] = -1;
        lleft[0] = -1;

        for (int i = 0; i < n; i++) ordered[i] = {-a[i], i};
        sort(ordered, ordered+n);

        int result = 0;
        for(int i = 0; i < n; i++) {
            int pos = ordered[i].second;
            int numlleft = 0;
            int numrright = 0;
            for(int curr = pos; lleft[curr] != -1 && numlleft+1 < k; numlleft++, curr = lleft[curr]);
            for(int curr = pos; rright[curr] != -1 && numrright+1 < k; numrright++, curr = rright[curr]);
            //cout << ordered[i].first << " " << numlleft << "  " << numrright << endl;
            result += max(0, numlleft + numrright + 2 - k);

            if(lleft[pos] != -1) rright[lleft[pos]] = rright[pos];
            if(rright[pos] != -1) lleft[rright[pos]] = lleft[pos];
        }
        if(result == p) cc++;

        //for(int i = 0; i < n; i++) cout << a[i] << " ";
        //cout << endl;
        //cout << "res: " << result << endl;
    } while (next_permutation(a, a+n));

    cout << cc << endl;
    return 0;
}
