#include <iostream>
using namespace std;


int n, k, p;
const int MAXN = 400;
const int MAXP = MAXN*MAXN;

long long dp[MAXP][2];

const long long MOD = 1e9+7;

inline long long get(int pi, int ni) {
    if(pi >= 0 && ni >= 0) return dp[pi][ni%2];
    else return 0;
}

int main() {
    cin >> n >> k >> p;

    if (p > n*k) {
        cout << 0 << endl;
        return 0;
    }

    for(int ni = 0; ni <= n; ni++) {
        for(int pi = 0; pi <= p; pi++) {

            long long result;
            if(ni == 0) {
                if(pi == 0) {
                    result = 1;
                } else {
                    result = 0;
                }
            } else {
                if(ni < k) result = ni*get(pi, ni-1);
                else {

                    int currMin = 1;
                    int currMax = min(k, ni - k + 1);

                    result = 0;
                    for (int curr = currMin; curr < currMax; curr++) { // SLOW
                            result = (result + get(pi-curr, ni-1)*2)%MOD;
                    }
                    result = (result + get(pi-currMax, ni-1)*(ni-2*currMax+2))%MOD;
                }
            }

            dp[pi][ni%2] = result%MOD;
        }
    }

    cout << dp[p][n%2] << endl;

    return 0;
}
