#include <iostream>
using namespace std;

const int MOD = 1000000007;
const int MAXN = 401;

int dp[MAXN][MAXN*MAXN];

int main() {
    int n,k,p;
    cin >> n >> k >> p;
    if (p > n*k) {
        cout << 0 << endl;
        return 0;
    }

    dp[k-1][0] = 1;
    for (int i = 1; i <= k-1; i++) {
        dp[k-1][0] = 1l*dp[k-1][0]*i%MOD;
    }

    for (int nn = k; nn <= n; nn++) {
        long cached = 0;
        for (int pp = 1; pp <= p; pp++) {
            int currentMax = min(k, nn - k + 1);
            if (pp - currentMax > 0) {
                cached -= dp[nn-1][pp-currentMax]*2l;
                if (cached >= MOD || cached <= -MOD) cached %= MOD;
            }

            long sum = cached;
            cached += dp[nn-1][pp] * 2l;
            if (cached >= MOD || cached <= -MOD) cached %= MOD;
            if (pp - currentMax >= 0) sum += 1l*dp[nn-1][pp-currentMax] * (nn-2*(currentMax-1));
            dp[nn][pp] = sum%MOD;
        }
    }
    if (dp[n][p] < 0) dp[n][p] += MOD;
    cout << dp[n][p] << endl;

    return 0;
}
